#!/local/bin/perl

# index.pl
# ========
# Mike Jahr, 7/26/99
# Machine Translation group, WS99
# Center for Language and Speech Processing
# 
# very simple script to index all ".aln" files in the current
# directory, recursively descending all subdirectories.
# lists all subdirectories before all files.

$OUTFILE = "index";
$SUFFIX = ".aln";

$root = shift;
unless ($root) {  # default is current dir
  if ($0 =~ m|/|) {
    $0 =~ m|(.*/)[^/]+|;
    $root = $1;
  } else {
    $root = "./";
  }
}
$root .= "/" unless $root =~ m|/\Z|;
$len = length($root);

print "index.pl: indexing directory $root\n";

open(OUT, ">$root$OUTFILE") || die "couldn't write to $OUTFILE\n";
dodir($root);

sub dodir {
  my $f = shift;
  #print "globbing $f\n";
  my @flist = glob($f."*");
  for $f (@flist) {
    #print "$f\n";
    if (-d $f) {
      dodir($f."/");
    } else {
      push(@_,substr($f,$len)) # strip directory prefix
	if ($f =~ /$SUFFIX\Z/);
    }
  }
  for $f (@_) {
    print OUT $f."\n";
  }
}
close OUT;

  
#  for $f (@flist) {
#    print OUT substr($f, 2)."\n" # strip "./"
#      if ($f =~ /$SUFFIX\Z/);
#    push(@_,$f) if (-d $f);
#  }
#  for $f (@_) {
#    dodir($f);
#  }

