/* CairoWrap.java
 * ==============
 * Mike Jahr, 8/16/99
 * Machine Translation group, WS99
 * Center for Language and Speech Processing
 */

import javax.swing.JMenu;
import javax.swing.RootPaneContainer;
import java.awt.Dimension;

/** 
 * Wrapper interface for Cairo.
 * This interface allows Cairo to run both an app and applet;
 * differences between the two versions needs to be here.
 * @author Mike Jahr
 * @see Cairo
*/
public interface CairoWrap extends RootPaneContainer {
    /** 
     * Creates a file menu specific to the app- or applet-version of Cairo.
     * Currently, the file menu is the only difference between the 
     * two versions.
     * @see Cairo#createFileMenu(Cairo)
     * @see CairoApplet#createFileMenu(Cairo)
     * @see FileMenuApp
     * @see FileMenuApplet
     */
    public JMenu createFileMenu(Cairo c);
    /** 
     * Returns the associated {@link Cairo Cairo} object.
     * @see Cairo#getCairo()
     * @see CairoApplet#getCairo()
     */
    public Cairo getCairo();
    /** 
     * Returns the current width.
     */
    public int getWidth();
    /** 
     * Returns the current height.
     */
    public int getHeight();
    /** 
     * Returns the current size.
     */
    public Dimension getSize();
}
