/* HelpMenu.java
 * =============
 * Mike Jahr, 8/13/99
 * Machine Translation group, WS99
 * Center for Language and Speech Processing
 * 
 * Help menu class for Cairo applet.
 */

import javax.swing.*;
import java.awt.event.*;
import java.net.URL;
import java.io.*;
import java.util.StringTokenizer;

/**
 * Implements a Help menu for Cairo.
 * Two choices: About and Help.
 * @author Mike Jahr
 * @see Cairo
 */
public class HelpMenu extends JMenu
    implements ActionListener {
    private Cairo master;
    
    /** Creates a Help menu for the given Cairo. */
    public HelpMenu(Cairo inc) {
	super("Help");
	master = inc;
	
	JMenuItem item;
	
	item = new JMenuItem(GET_HELP); //, KeyEvent.VK_O);
	item.addActionListener(this);
	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H, 
						   ActionEvent.ALT_MASK));
	add(item);
	
	addSeparator();
	
	item = new JMenuItem(ABOUT);
	item.addActionListener(this);
	add(item);
    }
    
    /**
     * Required by the <code>ActionListener</code> interface; responds to
     * <code>ActionEvents</code>.
     */
    public void actionPerformed(ActionEvent ae) {
	JMenuItem source = (JMenuItem)(ae.getSource());
	String action = source.getText();
	
	if (action.equals(GET_HELP)) {
	    JOptionPane.
		showMessageDialog(master, 
				  "Cairo help not yet implemented.", 
				  "Sorry",
				  JOptionPane.WARNING_MESSAGE);
	} else if (action.equals(ABOUT)) {
	    JOptionPane.
		showMessageDialog(master, Cairo.VERSION + "\n" +
				  Cairo.BYLINE, "About Cairo",
				  JOptionPane.INFORMATION_MESSAGE);
	}
	/*	JTextArea jte = new JTextArea(err, 6, 40);
		jte.setLineWrap(true);
		jte.setWrapStyleWord(true);
		//JScrollPane jsp = new JScrollPane(new JTextArea(err, 6, 40));
		JOptionPane.showOptionDialog
		(this, new JScrollPane(jte), "Cairo error", 
		JOptionPane.DEFAULT_OPTION,
		JOptionPane.WARNING_MESSAGE, null, null, null);
		
	*/
    }
    
    private static final String GET_HELP = "Cairo help...";
    private static final String ABOUT = "About Cairo...";
}// end class HelpMenu

