/* ProbTable.java
 * ==============
 * Mike Jahr, 7/16/99
 * Machine Translation group, WS99
 * Center for Language and Speech Processing
 * 
 * Table to display probabilities and strings.
 */

import javax.swing.JTable;
import java.awt.Color;
import java.util.Hashtable;
import javax.swing.table.*;
import java.awt.event.*;

public class ProbTable extends JTable {
    private int sortMethod;
    private boolean sortAscend;
    //private DefaultTableCellRenderer redRenderer;
    private Hashtable renderers;
    
    public ProbTable(TableModel tm) {
	super(tm);
	init();
    }
    
    public ProbTable() { //SPTableModel tm) {
	super(); //new DefaultTableModel(7, 2));
	init();
    }
    
    private void init() {
	sortMethod = 1; //StringProbComparator.PROBMETH;
	sortAscend = true;
	
	//redRenderer = new DefaultTableCellRenderer();
	//redRenderer.setForeground(Web.ACTIVE_WORD);
	renderers = new Hashtable();
	renderers.put(Color.black, new DefaultTableCellRenderer());
	setCellSelectionEnabled(false);
	setRowSelectionAllowed(false);
	setShowHorizontalLines(false);
	/*setColumnSelectionAllowed(true);
	setSelectionBackground(getBackground());
	setSelectionForeground(getForeground());*/

        final ProbTable pt = this;
        setColumnSelectionAllowed(false); 

        MouseAdapter headListener = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                TableColumnModel columnModel = pt.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                int column = pt.convertColumnIndexToModel(viewColumn);
                if (e.getClickCount() == 1 && column != -1) {
                    //*DBG*/System.err.println("sorting table by col " + column);
                    int shiftPressed = e.getModifiers()&InputEvent.SHIFT_MASK;
                    boolean ascending = (shiftPressed == 0);
                    pt.setSortMethod(column, ascending);
                }
            }
        };
        JTableHeader th = getTableHeader(); 
        th.addMouseListener(headListener); 
	th.setReorderingAllowed(false);
	setAutoResizeMode(AUTO_RESIZE_ALL_COLUMNS);
    }

    public TableCellRenderer getCellRenderer(int row, int col) {
	Color c = null;
	
	try {
	    c = ((SPTableModel) dataModel).rowColor(row);
	} catch (ClassCastException ignored) {
	    //System.err.println("Illegal data model in ProbTable.");
	    //cce.printStackTrace();
	}
	return (c == null) ? super.getCellRenderer(row, col) : 
	    getRenderer(c);
    }
    private TableCellRenderer getRenderer(Color c) {
	TableCellRenderer r = (TableCellRenderer) renderers.get(c);
	if (r == null) {
	    DefaultTableCellRenderer dtr = new DefaultTableCellRenderer();
	    dtr.setForeground(c);
	    renderers.put(c, dtr);
	    r = dtr;
	}
	return r; //new DefaultTableCellRenderer();
    }

    public void setSortMethod(int meth, boolean asc) {
	sortMethod = meth;
	sortAscend = asc;
	try {
	    ((SPTableModel) dataModel).setSortMethod(sortMethod, sortAscend);
	} catch (ClassCastException ignored) {
	    //System.err.println("Illegal data model in ProbTable.");
	    //cce.printStackTrace();
	}
    }

    
    public void setModel(TableModel tm) {
	//System.err.println("Illegal attempt to set ProbTable's model");
	try {
	    SPTableModel sptm = (SPTableModel) tm;
	    sptm.setSortMethod(sortMethod, sortAscend);
	} catch (ClassCastException ignored) { }
	super.setModel(tm);
    }

    /* private class RedRenderer extends DefaultTableCellRenderer {
	public Component 
	    getTableCellRendererComponent(JTable table, Object value,
					  boolean isSelected,
					  boolean hasFocus,
					  int row, int column) {
	    Component val;
	    if (sptm != null && sptm.isCorrect(row)) {
		Color prev = getForeground();
		setForeground(Web.ACTIVE_WORD);
		val = super(table, value, isSelected, hasFocus, row,
			    column);
		setForeground(prev);
	    } else {
		val = super(table, value, isSelected, hasFocus, row,
			    column);
			    }
	    return val;
	}
    }
    
    
    public void addMouseListenerToHeaderInTable(JTable table) { 
        //final TableSorter sorter = this; 
        final JTable t = this;
        setColumnSelectionAllowed(false); 

        MouseAdapter listMouseListener = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                TableColumnModel columnModel = t.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                int column = t.convertColumnIndexToModel(viewColumn);
                if (e.getClickCount() == 1 && column != -1) {
                    //System.out.println("Sorting ...");
                    int shiftPressed = e.getModifiers()&InputEvent.SHIFT_MASK;
                    boolean ascending = (shiftPressed == 0);
                    t.setSortMethod(column, ascending);
                }
            }
        };
        JTableHeader th = getTableHeader(); 
        th.addMouseListener(listMouseListener); 
    }

    private class HeaderMouseListener extends MouseAdapter {
	
	public void mouseClicked(MouseEvent e) {
	    
	}
    }
    */
}



    /*
    */

