/*
 * SourceWord class
 * Noah A. Smith, 13 July 1999
 * Last edited 19 July 1999
 * Statistical Machine Translation Team at WS '99
 */   

/** A Word in the source language (the one you translated from). 
    @author Noah A. Smith
    @see Word
*/
public class SourceWord extends Word {
    
    /** Instantiate source word 'text' in position 'i' of the source sentence with Web 'w'. */
    public SourceWord(String text, int i, Web w){
	super(text, i, w);
    }

    /* Create a link to a target word 'wrd'. 
    public void linkTo(TargetWord wrd){
	links.addElement(new Link(this, wrd));
	} */

    /** Return an empty table model (currently source language words have no fertility distribution). */
    public SPTableModel getFertilities(){
	return emptyFertTM;
    }

    /** Return an empty table model (currently source language words have no distortion distribution). */
    public SPTableModel getDistortions(){
	return emptyDistTM;
    }
    
    /** True. */
    public boolean isSource() {
	return true;
    }
}



